#########
# Author:        rmp
# Maintainer:    $Author: gq1 $
# Created:       2004-01-06
# Last Modified: $Date: 2008-11-06 15:46:38 +0000 (Thu, 06 Nov 2008) $
# Id:            $Id: LoggingDBI.pm 3386 2008-11-06 15:46:38Z gq1 $
# Source:        $Source: /repos/cvs/webcore/SHARED_docs/lib/core/LoggingDBI.pm,v $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/tags/release-4.0/lib-ext/LoggingDBI.pm $
#
package LoggingDBI;
use strict;
use warnings;
use DBI;

our $VERSION  = do { my @r = (q$Revision: 3386 $ =~ /\d+/mxg); sprintf '%d.'.'%03d' x $#r, @r };
our $AUTOLOAD;

sub connect {
  my ($class, @args) = @_;
  my $self  = {
               '_history' => [],
               '_dbh'     => DBI->connect(@args),
              };
  bless $self, $class;

  return $self;
}

sub connect_cached {
  my ($class, @args) = @_;
  my $self  = {
               '_history' => [],
               '_dbh'     => DBI->connect_cached(@args),
              };
  bless $self, $class;

  return $self;
}

sub profiler {
  my ($self, $profiler) = @_;
  if($profiler) {
    $self->{'_profiler'} = $profiler;
  }
  return $self->{'_profiler'};
}

sub AUTOLOAD {
  my ($self, @args) = @_;
  my ($func)        = $AUTOLOAD =~ /([^:]+)$/mx;
  my $profiler      = $self->profiler();
  my $summarytag    = join ' || ', map { $_||'undef' } @args;
  $summarytag       =~ s/\s+/ /mxg;
  my $aggregatetag  = $args[0]||q();
  $aggregatetag     =~ s/\s+/ /mxg;

  if($profiler && $aggregatetag)                               { $profiler->begin("DBI ($func) aggregate: $aggregatetag"); }
  if($profiler && $summarytag && $aggregatetag ne $summarytag) { $profiler->begin("DBI ($func): $summarytag"); }
  my $result;
  if(defined $self->{'_dbh'}) {
    $result = $self->{'_dbh'}->$func(@args);
  }
  if($profiler && $summarytag && $aggregatetag ne $summarytag) { $profiler->end("DBI ($func): $summarytag"); }
  if($profiler && $aggregatetag)                               { $profiler->end("DBI ($func) aggregate: $aggregatetag"); }
  return $result;
}

1;
