#########
# Author:        gq1
# Maintainer:    $Author: gq1 $
# Created:       2008-10-23
# Last Modified: $Date: 2008-11-06 15:46:38 +0000 (Thu, 06 Nov 2008) $
# Id:            $Id: 10-model-instrument_statistics.t 3386 2008-11-06 15:46:38Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/tags/release-4.0/t/10-model-instrument_statistics.t $
#

use strict;
use warnings;
use Test::More  tests => 8;
use English qw(-no_match_vars);
use SangerPaths qw(core tracking badger ensembl);
use IO::Scalar;
use lib qw{t};
use t::util;
use npg_qc::model::instrument_statistics;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3386 $ =~ /(\d+)/mx; $r; };

##
use_ok('npg_qc::model::instrument_statistics');

##
my $util = t::util->new({fixtures =>1});

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util});
  isa_ok($model, 'npg_qc::model::instrument_statistics', '$model');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util});
  eval{
    $model->save();
    1;
  };
  like($EVAL_ERROR, qr{Column\ \'id_run\'\ cannot\ be\ null}, 'id_run can not be null');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util,
                                                         id_run =>5,
                                                        });
  eval{
    $model->save();
    1;
  };
  like($EVAL_ERROR, qr{Column\ \'end\'\ cannot\ be\ null}, 'end can not be null');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util,
                                                         id_run =>10,
                                                         end    =>1,
                                                        });
  eval{
    $model->save();
    1;
  };
  like($EVAL_ERROR, qr{Column\ \'id_run_actual\'\ cannot\ be\ null}, 'id_run_actual can not be null');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util,
                                                         id_run =>10,
                                                         end    =>1,
                                                         id_run_actual =>10,
                                                        });
  eval{
    $model->save();
    1;
  };
  like($EVAL_ERROR, qr{Column\ \'instrument\'\ cannot\ be\ null}, 'instrument can not be null');
}

##
{
  my $model = npg_qc::model::instrument_statistics->new({util => $util,
                                                         id_run =>10,
                                                         end    =>1,
                                                         id_run_actual =>10,
                                                         instrument  => 'IL8',
                                                        });
  eval{
    $model->save();
    1;
  };
  is($EVAL_ERROR, q{}, 'saving ok');

  eval{
    $model->save();
    1;
  };
  is($EVAL_ERROR, q{}, 're-saving ok');
}
