#########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-07-22
# Last Modified: $Date: 2008-11-06 15:46:38 +0000 (Thu, 06 Nov 2008) $
# Id:            $Id: 20-view-cumulative_errors_by_cycle.t 3386 2008-11-06 15:46:38Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/tags/release-4.0/t/20-view-cumulative_errors_by_cycle.t $
#

use strict;
use warnings;
use Test::More tests => 7;
use English qw(-no_match_vars);
use SangerPaths qw(core tracking badger ensembl);
use IO::Scalar;
use lib qw{t};
use t::util;
use Carp;
use npg_qc::model::cumulative_errors_by_cycle;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3386 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::view::cumulative_errors_by_cycle');

my $util  = t::util->new({fixtures => 1});
{
  my $cgi = $util->cgi();
  $cgi->param('id_run', 1);

  my $model = npg_qc::model::cumulative_errors_by_cycle->new({util => $util});

  my $view  = npg_qc::view::cumulative_errors_by_cycle->new({
    util   => $util,
    model  => $model,
    action => 'list',
    aspect => q{},
  });
  isa_ok($view, 'npg_qc::view::cumulative_errors_by_cycle', '$view');

  my $render;
  eval { $render = $view->render(); };
  is($EVAL_ERROR, q{}, 'no croak on render list');
  ok($util->test_rendered($render, 't/data/rendered/html/cumulative_errors_by_cycle_list.html'), 'list rendered ok');
}
{
  my $cgi = $util->cgi();
  $cgi->param('tile_ref', '1_1_1');
  $cgi->param('score', 'score');

  my $model = npg_qc::model::cumulative_errors_by_cycle->new({util => $util});

  my $view  = npg_qc::view::cumulative_errors_by_cycle->new({
    util   => $util,
    model  => $model,
    action => q{read},
    aspect => q{read_png},
  });

  my $render;
  is($view->authorised, 1, 'all are authorised');
  is($view->decor(), 0, 'decor is 0 for read_png');
  is($view->content_type(), 'image/png', 'content_type is image/png for read_png');
}
