#########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-06-16
# Last Modified: $Date: 2008-11-06 15:46:38 +0000 (Thu, 06 Nov 2008) $
# Id:            $Id: 20-view-main.t 3386 2008-11-06 15:46:38Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/tags/release-4.0/t/20-view-main.t $
#

use strict;
use warnings;
use Test::More 'no_plan';#tests => 36;
use English qw(-no_match_vars);
use SangerPaths qw(core tracking badger ensembl);
use IO::Scalar;
use lib qw{t};
use t::util;
use npg_qc::model::main;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3386 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::view::main');
my $util = t::util->new({fixtures => 1});

my $model = npg_qc::model::main->new({util => $util});
{
  my $view = npg_qc::view::main->new({
    util   => $util,
    model  => $model,
    action => q{list},
    aspect => q{},
  });
  isa_ok($view, 'npg_qc::view::main', '$view');
  my $render;
  eval { $render = $view->render(); };
  is($EVAL_ERROR, q{}, 'no croak on render list');
  ok($util->test_rendered($render, 't/data/rendered/html/main_list.html'), 'list render is ok');
}
