#########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-07-23
# Last Modified: $Date: 2008-11-06 15:46:38 +0000 (Thu, 06 Nov 2008) $
# Id:            $Id: 30-api-run_config.t 3386 2008-11-06 15:46:38Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/tags/release-4.0/t/30-api-run_config.t $
#

use strict;
use warnings;
use Test::More tests => 10;
use English qw(-no_match_vars);
use IO::Scalar;
use lib qw{t};
use t::api::util;
use npg::api::util;
use t::useragent;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3386 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::api::run_config');
{
  my $ua_mock = {
    q{http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc//run_config}   => q{t/data/requests/cgi-bin/prodsoft/npg_qc/npg_qc/run_config.xml},
  };

  my $ua   = t::useragent->new({is_success => 1, mock => $ua_mock});
  my $npg_api_util = npg::api::util->new({useragent => $ua});
  my $util = t::api::util->new({dbh => 'dummy', npg_api_util => $npg_api_util, fixtures => 0, useragent => $ua, parser => 0, base_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/', npg_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg/npg/'});
  my $run_config = npg_qc::api::run_config->new({util => $util});
  isa_ok($run_config, 'npg_qc::api::run_config', '$run_config');
  my @fields = $run_config->fields();
  is($fields[0], 'id_run_config', '$run_config->fields()[0] is id_run_config');
  my $run_configs;
  eval { $run_configs = $run_config->run_configs(); };
  is($EVAL_ERROR, q{}, 'no croak on obtaining run_configs');
  isa_ok($run_configs, 'ARRAY', '$run_configs');
  isa_ok($run_configs->[0], 'npg_qc::api::run_config', '$run_configs->[0]');
  is($run_configs->[0]->id_run_config(), 1, '$run_configs->[0]->id_run_config() is ok');
  is($run_configs->[0]->id_run(), 1, '$run_configs->[0]->id_run() is ok');
  is($run_configs->[0]->config_text(), 1, '$run_configs->[0]->config_text() is ok');
}
{
  my $ua_mock = {};

  my $ua   = t::useragent->new({is_success => 0, mock => $ua_mock});
  my $npg_api_util = npg::api::util->new({useragent => $ua});
  my $util = t::api::util->new({dbh => 'dummy', npg_api_util => $npg_api_util, fixtures => 0, useragent => $ua, parser => 0, base_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/', npg_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg/npg/'});
  my $run_config = npg_qc::api::run_config->new({util => $util});
  my $run_configs;
  eval { $run_configs = $run_config->run_configs(); };
  like($EVAL_ERROR, qr{error\ in\ t::useragent}, 'croaked if no success obtaining run_configs via LWP');
}
1;
