#########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-09-29
# Last Modified: $Date: 2008-11-06 15:46:38 +0000 (Thu, 06 Nov 2008) $
# Id:            $Id: 30-api-summary.t 3386 2008-11-06 15:46:38Z gq1 $
# $HeadURL: svn+ssh://svn.internal.sanger.ac.uk/repos/svn/new-pipeline-dev/npg-qc/tags/release-4.0/t/30-api-summary.t $
#

use strict;
use warnings;
use Test::More tests => 22;
use English qw(-no_match_vars);
use IO::Scalar;
use lib qw{t};
use t::api::util;
use npg::api::util;
use t::useragent;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3386 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::api::summary');
{
  my $ua_mock = {};

  my $ua   = t::useragent->new({is_success => 0, mock => $ua_mock});
  my $npg_api_util = npg::api::util->new({useragent => $ua});
  my $util = t::api::util->new({dbh => 'dummy', npg_api_util => $npg_api_util, fixtures => 0, useragent => $ua, parser => 0, base_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/', npg_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg/npg/'});
  my $summary = npg_qc::api::summary->new({util => $util});
  isa_ok($summary, 'npg_qc::api::summary', '$summary');
  my $summaries;
  eval { $summaries = $summary->complete_runs(); };
  like($EVAL_ERROR, qr{error\ in\ t::useragent}, 'croaked if no success obtaining run_configs via LWP');
}
{
  my $ua_mock = {
    q{http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc//summary}   => q{t/data/requests/cgi-bin/prodsoft/npg_qc/npg_qc/completed_run_summary.xml},
  };

  my $ua   = t::useragent->new({is_success => 1, mock => $ua_mock});
  my $npg_api_util = npg::api::util->new({useragent => $ua});
  my $util = t::api::util->new({dbh => 'dummy', npg_api_util => $npg_api_util, fixtures => 0, useragent => $ua, parser => 0, base_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/', npg_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg/npg/'});
  my $summary = npg_qc::api::summary->new({util => $util});
  isa_ok($summary, 'npg_qc::api::summary', '$summary');
  my @fields = $summary->fields();
  is($fields[0], 'id_run', '$summary->fields()[0] is id_run');
  my $summaries;
  eval { $summaries = $summary->complete_runs(); };
  is($EVAL_ERROR, q{}, 'no croak on obtaining complete_run_summaries');
  isa_ok($summaries, 'ARRAY', '$summaries');
  is(scalar@{$summaries}, 8, '8 runs obtained');
  isa_ok($summaries->[0], 'npg_qc::api::summary', '$summaries->[0]');
  is($summaries->[0]->id_run(), 1, '$summaries->[0]->id_run() is ok');
  is($summaries->[0]->end(), 1, '$summaries->[0]->end() is ok');
  is($summaries->[0]->paired(), undef, '$summaries->[0]->paired() is ok');
  is($summaries->[-1]->id_run(), 956, '$summaries->[-1]->id_run() is ok');
  is($summaries->[-1]->end(), 1, '$summaries->[-1]->end() is ok');
  is($summaries->[-1]->paired(), 1, '$summaries->[-1]->paired() is ok');

  is($summary->complete_runs(), $summaries, 'complete runs cached within object');

  my $fully_complete_summaries;
  eval { $fully_complete_summaries = $summary->runs_with_fully_complete_pairs(); };
  is($EVAL_ERROR, q{}, 'no croak on obtaining fully_complete_run_summaries');
  isa_ok($fully_complete_summaries, 'ARRAY', '$fully_complete_summaries');
  is(scalar@{$fully_complete_summaries}, 4, '4 runs obtained');
  isa_ok($fully_complete_summaries->[0], 'npg_qc::api::summary', '$fully_complete_summaries->[0]');
  is($fully_complete_summaries->[-1]->id_run(), 4, '$fully_complete_summaries->[-1]->id_run() is ok');
  is($fully_complete_summaries->[-1]->end(), 1, '$fully_complete_summaries->[-1]->end() is ok');

}
1;
